"use strict";var __importDefault=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(exports,"__esModule",{value:!0}),exports.findTable=exports.parseArray=exports.parseInlineTable=exports.parseKey=exports.extractValue=exports.parseValue=exports.parseContent=void 0;const toml_util_1=require("./toml-util"),custom_toml_error_1=__importDefault(require("./custom-toml-error")),custom_toml_date_1=__importDefault(require("./custom-toml-date")),toml_constants_1=require("./toml-constants");function splitContent(e,t,r,o){let{startPos:n,parsedRes:l,sliceStart:s,isEscape:i,tempPosition:a}=o;const u=e[n++];if(("\n"===u||"\r"===u&&"\n"===e[n])&&!t)throw new custom_toml_error_1.default("newlines are not allowed in strings",e,n-1);if(u<" "&&"\t"!==u||""===u)throw new custom_toml_error_1.default("control characters are not allowed in strings",e,n-1);if(!0===i){if(i=!1,"u"===u||"U"===u){const t=e.slice(n,n+="u"===u?toml_constants_1.LOWER_CHARACTER_LENGTH:toml_constants_1.UPPER_CHARACTER_LENGTH);if(!toml_constants_1.ESCAPE_REGEX.test(t))throw new custom_toml_error_1.default("invalid unicode escape",e,a);l+=String.fromCodePoint(parseInt(t,16))}else if(t&&(0,toml_util_1.isNewLineOrSpace)(u)){if(n=(0,toml_util_1.skipVoidChar)(e,n-1,!0),"\n"!==e[n]&&"\r"!==e[n])throw new custom_toml_error_1.default("invalid escape: only line-ending whitespace may be escaped",e,a);n=(0,toml_util_1.skipVoidChar)(e,n)}else{if(!(u in toml_constants_1.ESCAPE_SYMBOL_MAP))throw new custom_toml_error_1.default("unrecognized escape sequence",e,a);l+=toml_constants_1.ESCAPE_SYMBOL_MAP[u]}s=n}else r||"\\"!==u||(a=n-1,i=!0,l+=e.slice(s,a));return{startPos:n,parsedRes:l,sliceStart:s,isEscape:i,tempPosition:a}}function doParseContent(e,t,r,o,n){let l=e,s=0,i=!1,a="",u=l;for(;l<t-1;){const e=splitContent(r,o,n,{startPos:l,parsedRes:a,sliceStart:u,isEscape:i,tempPosition:s});({startPos:l,parsedRes:a,sliceStart:u,isEscape:i,tempPosition:s}=e)}return a+r.slice(u,t-1)}function parseContent(e,t=0,r=e.length){let o=t,n=r;const l="'"===e[o],s=e[o++]===e[o]&&e[o]===e[o+1];return s&&(n-=toml_constants_1.TWO_POS_OFFSET,"\r"===e[o+=toml_constants_1.TWO_POS_OFFSET]&&o++,"\n"===e[o]&&o++),doParseContent(o,n,e,s,l)}function parseValue(e,t,r){if("true"===e)return!0;if("false"===e)return!1;if("-inf"===e)return-1/0;if("inf"===e||"+inf"===e)return 1/0;if("nan"===e||"+nan"===e||"-nan"===e)return NaN;if("-0"===e)return 0;const o=toml_constants_1.INT_REGEX.test(e);if(o||toml_constants_1.FLOAT_REGEX.test(e)){if(toml_constants_1.LEADING_ZERO_REGEX.test(e))throw new custom_toml_error_1.default("leading zeros are not allowed",t,r);const n=+Number(e.replace(/_/g,""));if(isNaN(n))throw new custom_toml_error_1.default("invalid number",t,r);if(o&&!Number.isSafeInteger(n))throw new custom_toml_error_1.default("integer value cannot be represented losslessly",t,r);return n}const n=custom_toml_date_1.default.createCustomTomlDate(e);if(!n.isValid())throw new custom_toml_error_1.default("invalid value",t,r);return n}function extractStringValue(e,t,r){let o=(0,toml_util_1.getStringEnd)(e,t);const n=parseContent(e,t,o);if(null!=r&&""!==r){o=(0,toml_util_1.skipVoidChar)(e,o,"]"!==r);if(!(0,toml_util_1.isEmpty)(e[o])&&","!==e[o]&&e[o]!==r&&"\n"!==e[o]&&"\r"!==e[o])throw new custom_toml_error_1.default("unexpected character encountered",e,o);o+=+Number(","===e[o])}return[n,o]}function extractValue(e,t,r){const o=e[t];if("["===o||"{"===o){const[n,l]="["===o?parseArray(e,t):parseInlineTable(e,t),s=(0,toml_util_1.skipUnusedCharacters)(e,l,",",r);if("}"===r){const t=(0,toml_util_1.getNewlineIndex)(e,l,s);if(t>-1)throw new custom_toml_error_1.default("newlines are not allowed in inline tables",e,t)}return[n,s]}if('"'===o||"'"===o)return extractStringValue(e,t,r);let n=(0,toml_util_1.skipUnusedCharacters)(e,t,",",r);const l=(0,toml_util_1.removeCommentTrimEnd)(e,t,n-+Number(","===e[n-1]),"]"===r);if((0,toml_util_1.isEmpty)(l[0]))throw new custom_toml_error_1.default("unspecified values are invalid",e,t);return null!=r&&""!==r&&l[1]>-1&&(n=(0,toml_util_1.skipVoidChar)(e,t+l[1]),n+=+Number(","===e[n])),[parseValue(l[0],e,t),n]}function doParseKey(e,t){const{character:r,contentStr:o,startPos:n,endCharacter:l}=e;let{dotPos:s,endPos:i}=e;if('"'===r||"'"===r){if(r===o[n+1]&&r===o[n+toml_constants_1.TWO_POS_OFFSET])throw new custom_toml_error_1.default("multiline strings are not allowed in keys",o,n);const e=(0,toml_util_1.getStringEnd)(o,n);if(e<0)throw new custom_toml_error_1.default("unfinished string encountered",o,n);s=o.indexOf(".",e);const a=o.slice(e,s<0||s>i?i:s),u=(0,toml_util_1.getNewlineIndex)(a);if(u>-1)throw new custom_toml_error_1.default("newlines are not allowed in keys",o,n+s+u);if(!(0,toml_util_1.isEmpty)(a.trimStart()))throw new custom_toml_error_1.default("found extra tokens after the string part",o,e);if(i<e&&(i=o.indexOf(l,e),i<0))throw new custom_toml_error_1.default("incomplete key-value: cannot find end of key",o,n);t.push(parseContent(o,n,e))}else{s=o.indexOf(".",n);const e=o.slice(n,s<0||s>i?i:s);if(!toml_constants_1.KEY_PART_REGEX.test(e))throw new custom_toml_error_1.default("only ASCII letters, ASCII digits, underscores and dashes are allowed in keys",o,n);t.push(e.trimEnd())}return{dotPos:s,endPos:i}}function parseKey(e,t,r="="){let o=t,n=o-1;const l=[];let s=e.indexOf(r,o);if(s<0)throw new custom_toml_error_1.default("incomplete key-value: cannot find end of key",e,o);do{const t=e[o=++n];if(" "===t||"\t"===t)continue;const i=doParseKey({character:t,contentStr:e,startPos:o,dotPos:n,endPos:s,endCharacter:r},l);({dotPos:n,endPos:s}=i)}while(n+1&&n<s);return[l,(0,toml_util_1.skipVoidChar)(e,s+1,!0)]}function doParseInlineTable(e,t,r,o,n){let l=r,s=n,i="",a=e,u=!1;const[_,c]=parseKey(t,l-1);for(let e=0;e<_.length;e++){if(e>0&&(a=u?a[i]:a[i]={}),i=_[e],(u=Object.prototype.hasOwnProperty.call(a,i))&&("object"!=typeof a[i]||o.has(a[i])))throw new custom_toml_error_1.default("repeatedly defined key",t,l);u||"__proto__"!==i||Object.defineProperty(a,i,{enumerable:!0,configurable:!0,writable:!0})}if(u)throw new custom_toml_error_1.default("repeatedly defined value",t,l);const[d,m]=extractValue(t,c,"}");return o.add(d),a[i]=d,l=m,s=","===t[l-1]?l-1:0,{position:l,comma:s}}function parseInlineTable(e,t){const r={},o=new Set;let n,l=0,s=t;for(s++;"}"!==(n=e[s++])&&!(0,toml_util_1.isEmpty)(n);){if("\n"===n)throw new custom_toml_error_1.default("newlines are not allowed in inline tables",e,s-1);if("#"===n)throw new custom_toml_error_1.default("inline tables cannot contain comments",e,s-1);if(","===n)throw new custom_toml_error_1.default("expected key-value, found comma",e,s-1);if(" "!==n&&"\t"!==n){const t=doParseInlineTable(r,e,s,o,l);({position:s,comma:l}=t)}}if(l)throw new custom_toml_error_1.default("trailing commas are not allowed in inline tables",e,l);if((0,toml_util_1.isEmpty)(n))throw new custom_toml_error_1.default("unfinished table encountered",e,s);return[r,s]}function parseArray(e,t){let r=t;const o=[];let n;for(r++;"]"!==(n=e[r++])&&!(0,toml_util_1.isEmpty)(n);){if(","===n)throw new custom_toml_error_1.default("expected value, found comma",e,r-1);if("#"===n)r=(0,toml_util_1.skipComment)(e,r);else if(!(0,toml_util_1.isNewLineOrSpace)(n)){const[t,n]=extractValue(e,r-1,"]");o.push(t),r=n}}if((0,toml_util_1.isEmpty)(n))throw new custom_toml_error_1.default("unfinished array encountered",e,r);return[o,r]}function defineProperties(e,t,r){const{hasProperty:o,propertyKey:n,i:l,keys:s,objType:i}=r;o||("__proto__"===n&&(Object.defineProperty(e,n,{enumerable:!0,configurable:!0,writable:!0}),Object.defineProperty(t,n,{enumerable:!0,configurable:!0,writable:!0})),t[n]={objType:l<s.length-1&&2===i?3:i,undo:!1,index:0,record:{}})}function dealArray(e,t,r,o){return 2===e&&(t.undo||(t.undo=!0,r[o]=[]),r[o].push(r={}),t.record[t.index++]=t={objType:1,undo:!1,index:0,record:{}}),{state:t,table:r}}function findTable(e,t,r,o){var n,l;let s,i=t,a=r,u="",_=!1;for(let t=0;t<e.length;t++){if(t>0){if(i=_?i[u]:i[u]={},a=(s=a[u]).record,0===o&&(1===s.objType||2===s.objType))return null;if(2===s.objType){const e=i.length-1;i=i[e],a=a[e].record}}if(u=e[t],(_=Object.prototype.hasOwnProperty.call(i,u))&&0===(null===(n=a[u])||void 0===n?void 0:n.objType)&&(null===(l=a[u])||void 0===l?void 0:l.undo))return null;defineProperties(i,a,{hasProperty:_,propertyKey:u,i:t,keys:e,objType:o})}if(s=a[u],s.objType!==o&&(1!==o||3!==s.objType))return null;const c=dealArray(o,s,i,u);if(({state:s,table:i}=c),s.undo)return null;if(s.undo=!0,1===o)i=_?i[u]:i[u]={};else if(0===o&&_)return null;return[u,i,s.record]}exports.parseContent=parseContent,exports.parseValue=parseValue,exports.extractValue=extractValue,exports.parseKey=parseKey,exports.parseInlineTable=parseInlineTable,exports.parseArray=parseArray,exports.findTable=findTable;